//  Created by dasdom on 17.11.19.
//  Copyright © 2019 dasdom. All rights reserved.
//

import UIKit
import CoreLocation
import LogStore

class LocationProvider: NSObject, CLLocationManagerDelegate {

  private let locationManager: CLLocationManager
  private let updateHandler: (CLLocation?, Error?) -> Void
  var updating = false
  
  /*
  override init() {
  */
  init(updateHandler: @escaping (CLLocation?, Error?)->Void) {
    
    locationManager = CLLocationManager()
    self.updateHandler = updateHandler
    
    super.init()

    locationManager.delegate = self
    locationManager.distanceFilter = 2
    locationManager.requestWhenInUseAuthorization()
  }
  
  // MARK: - CLLocationManagerDelegate
  
  func locationManager(_ manager: CLLocationManager,
                       didChangeAuthorization status:
                       CLAuthorizationStatus) {
    
    switch status {
    case .authorizedWhenInUse:
      printLog("success")
    default:
      // you will implement the other cases
      // in the exercises
      break
    }
  }
  
  func locationManager(_ manager: CLLocationManager,
                       didUpdateLocations locations: [CLLocation]) {
    /*
    printLog("locations: \(locations)")
    */
    guard let location = locations.last else { return }
    updateHandler(location, nil)
  }
  
  // MARK: -
  
  func start() {
    locationManager.startUpdatingLocation()
    updating = true
    locationManager.allowsBackgroundLocationUpdates = true
  }
  
  func stop() {
    locationManager.stopUpdatingLocation()
    updating = false
    
    locationManager.allowsBackgroundLocationUpdates = false
  }
}
